﻿//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     //
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

namespace ServiceReference1
{
    using System.Runtime.Serialization;
    
    
    [System.Diagnostics.DebuggerStepThroughAttribute()]
    [System.CodeDom.Compiler.GeneratedCodeAttribute("dotnet-svcutil", "1.0.0.1")]
    [System.Runtime.Serialization.DataContractAttribute(Name="FaultExceptionDetail", Namespace="http://schemas.datacontract.org/2004/07/IBC.HCAI.SoapExceptionWrapper")]
    public partial class FaultExceptionDetail : object
    {
        
        private string _errorCodeField;
        
        private string _errorMessageField;
        
        [System.Runtime.Serialization.DataMemberAttribute(IsRequired=true)]
        public string _errorCode
        {
            get
            {
                return this._errorCodeField;
            }
            set
            {
                this._errorCodeField = value;
            }
        }
        
        [System.Runtime.Serialization.DataMemberAttribute(IsRequired=true)]
        public string _errorMessage
        {
            get
            {
                return this._errorMessageField;
            }
            set
            {
                this._errorMessageField = value;
            }
        }
    }
    
    [System.CodeDom.Compiler.GeneratedCodeAttribute("dotnet-svcutil", "1.0.0.1")]
    [System.ServiceModel.ServiceContractAttribute(ConfigurationName="ServiceReference1.IService")]
    public interface IService
    {
        
        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IService/SendNeCSTMessage", ReplyAction="http://tempuri.org/IService/SendNeCSTMessageResponse")]
        [System.ServiceModel.FaultContractAttribute(typeof(ServiceReference1.FaultExceptionDetail), Action="http://tempuri.org/IService/SendNeCSTMessageFaultExceptionDetailFault", Name="FaultExceptionDetail", Namespace="http://schemas.datacontract.org/2004/07/IBC.HCAI.SoapExceptionWrapper")]
        System.Threading.Tasks.Task<System.Xml.Linq.XElement> SendNeCSTMessageAsync(System.Xml.Linq.XElement neCST_xml);
        
        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IService/GetFacilityInfo", ReplyAction="http://tempuri.org/IService/GetFacilityInfoResponse")]
        [System.ServiceModel.FaultContractAttribute(typeof(ServiceReference1.FaultExceptionDetail), Action="http://tempuri.org/IService/GetFacilityInfoFaultExceptionDetailFault", Name="FaultExceptionDetail", Namespace="http://schemas.datacontract.org/2004/07/IBC.HCAI.SoapExceptionWrapper")]
        System.Threading.Tasks.Task<System.Xml.Linq.XElement> GetFacilityInfoAsync();
        
        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IService/GetInsurerList", ReplyAction="http://tempuri.org/IService/GetInsurerListResponse")]
        [System.ServiceModel.FaultContractAttribute(typeof(ServiceReference1.FaultExceptionDetail), Action="http://tempuri.org/IService/GetInsurerListFaultExceptionDetailFault", Name="FaultExceptionDetail", Namespace="http://schemas.datacontract.org/2004/07/IBC.HCAI.SoapExceptionWrapper")]
        System.Threading.Tasks.Task<System.Xml.Linq.XElement> GetInsurerListAsync();
        
        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IService/AddProviderInfo", ReplyAction="http://tempuri.org/IService/AddProviderInfoResponse")]
        [System.ServiceModel.FaultContractAttribute(typeof(ServiceReference1.FaultExceptionDetail), Action="http://tempuri.org/IService/AddProviderInfoFaultExceptionDetailFault", Name="FaultExceptionDetail", Namespace="http://schemas.datacontract.org/2004/07/IBC.HCAI.SoapExceptionWrapper")]
        System.Threading.Tasks.Task<System.Xml.Linq.XElement> AddProviderInfoAsync(System.Xml.Linq.XElement pProviderXml);
        
        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IService/UpdateProviderInfo", ReplyAction="http://tempuri.org/IService/UpdateProviderInfoResponse")]
        [System.ServiceModel.FaultContractAttribute(typeof(ServiceReference1.FaultExceptionDetail), Action="http://tempuri.org/IService/UpdateProviderInfoFaultExceptionDetailFault", Name="FaultExceptionDetail", Namespace="http://schemas.datacontract.org/2004/07/IBC.HCAI.SoapExceptionWrapper")]
        System.Threading.Tasks.Task<System.Xml.Linq.XElement> UpdateProviderInfoAsync(System.Xml.Linq.XElement pProviderXml);
        
        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IService/UpdateFacilityInfo", ReplyAction="http://tempuri.org/IService/UpdateFacilityInfoResponse")]
        [System.ServiceModel.FaultContractAttribute(typeof(ServiceReference1.FaultExceptionDetail), Action="http://tempuri.org/IService/UpdateFacilityInfoFaultExceptionDetailFault", Name="FaultExceptionDetail", Namespace="http://schemas.datacontract.org/2004/07/IBC.HCAI.SoapExceptionWrapper")]
        System.Threading.Tasks.Task<System.Xml.Linq.XElement> UpdateFacilityInfoAsync(System.Xml.Linq.XElement pFacilityXml);
    }
    
    [System.CodeDom.Compiler.GeneratedCodeAttribute("dotnet-svcutil", "1.0.0.1")]
    public interface IServiceChannel : ServiceReference1.IService, System.ServiceModel.IClientChannel
    {
    }
    
    [System.Diagnostics.DebuggerStepThroughAttribute()]
    [System.CodeDom.Compiler.GeneratedCodeAttribute("dotnet-svcutil", "1.0.0.1")]
    public partial class ServiceClient : System.ServiceModel.ClientBase<ServiceReference1.IService>, ServiceReference1.IService
    {
        
    /// <summary>
    /// Implement this partial method to configure the service endpoint.
    /// </summary>
    /// <param name="serviceEndpoint">The endpoint to configure</param>
    /// <param name="clientCredentials">The client credentials</param>
    static partial void ConfigureEndpoint(System.ServiceModel.Description.ServiceEndpoint serviceEndpoint, System.ServiceModel.Description.ClientCredentials clientCredentials);
        
        public ServiceClient() : 
                base(ServiceClient.GetDefaultBinding(), ServiceClient.GetDefaultEndpointAddress())
        {
            this.Endpoint.Name = EndpointConfiguration.WSHttpBinding_IService.ToString();
            ConfigureEndpoint(this.Endpoint, this.ClientCredentials);
        }
        
        public ServiceClient(EndpointConfiguration endpointConfiguration) : 
                base(ServiceClient.GetBindingForEndpoint(endpointConfiguration), ServiceClient.GetEndpointAddress(endpointConfiguration))
        {
            this.Endpoint.Name = endpointConfiguration.ToString();
            ConfigureEndpoint(this.Endpoint, this.ClientCredentials);
        }
        
        public ServiceClient(EndpointConfiguration endpointConfiguration, string remoteAddress) : 
                base(ServiceClient.GetBindingForEndpoint(endpointConfiguration), new System.ServiceModel.EndpointAddress(remoteAddress))
        {
            this.Endpoint.Name = endpointConfiguration.ToString();
            ConfigureEndpoint(this.Endpoint, this.ClientCredentials);
        }
        
        public ServiceClient(EndpointConfiguration endpointConfiguration, System.ServiceModel.EndpointAddress remoteAddress) : 
                base(ServiceClient.GetBindingForEndpoint(endpointConfiguration), remoteAddress)
        {
            this.Endpoint.Name = endpointConfiguration.ToString();
            ConfigureEndpoint(this.Endpoint, this.ClientCredentials);
        }
        
        public ServiceClient(System.ServiceModel.Channels.Binding binding, System.ServiceModel.EndpointAddress remoteAddress) : 
                base(binding, remoteAddress)
        {
        }
        
        public System.Threading.Tasks.Task<System.Xml.Linq.XElement> SendNeCSTMessageAsync(System.Xml.Linq.XElement neCST_xml)
        {
            return base.Channel.SendNeCSTMessageAsync(neCST_xml);
        }
        
        public System.Threading.Tasks.Task<System.Xml.Linq.XElement> GetFacilityInfoAsync()
        {
            return base.Channel.GetFacilityInfoAsync();
        }
        
        public System.Threading.Tasks.Task<System.Xml.Linq.XElement> GetInsurerListAsync()
        {
            return base.Channel.GetInsurerListAsync();
        }
        
        public System.Threading.Tasks.Task<System.Xml.Linq.XElement> AddProviderInfoAsync(System.Xml.Linq.XElement pProviderXml)
        {
            return base.Channel.AddProviderInfoAsync(pProviderXml);
        }
        
        public System.Threading.Tasks.Task<System.Xml.Linq.XElement> UpdateProviderInfoAsync(System.Xml.Linq.XElement pProviderXml)
        {
            return base.Channel.UpdateProviderInfoAsync(pProviderXml);
        }
        
        public System.Threading.Tasks.Task<System.Xml.Linq.XElement> UpdateFacilityInfoAsync(System.Xml.Linq.XElement pFacilityXml)
        {
            return base.Channel.UpdateFacilityInfoAsync(pFacilityXml);
        }
        
        public virtual System.Threading.Tasks.Task OpenAsync()
        {
            return System.Threading.Tasks.Task.Factory.FromAsync(((System.ServiceModel.ICommunicationObject)(this)).BeginOpen(null, null), new System.Action<System.IAsyncResult>(((System.ServiceModel.ICommunicationObject)(this)).EndOpen));
        }
        
        public virtual System.Threading.Tasks.Task CloseAsync()
        {
            return System.Threading.Tasks.Task.Factory.FromAsync(((System.ServiceModel.ICommunicationObject)(this)).BeginClose(null, null), new System.Action<System.IAsyncResult>(((System.ServiceModel.ICommunicationObject)(this)).EndClose));
        }
        
        private static System.ServiceModel.Channels.Binding GetBindingForEndpoint(EndpointConfiguration endpointConfiguration)
        {
            if ((endpointConfiguration == EndpointConfiguration.WSHttpBinding_IService))
            {
                System.ServiceModel.Channels.CustomBinding result = new System.ServiceModel.Channels.CustomBinding();
                System.ServiceModel.Channels.TextMessageEncodingBindingElement textBindingElement = new System.ServiceModel.Channels.TextMessageEncodingBindingElement();
                result.Elements.Add(textBindingElement);
                System.ServiceModel.Channels.HttpsTransportBindingElement httpsBindingElement = new System.ServiceModel.Channels.HttpsTransportBindingElement();
                httpsBindingElement.AllowCookies = true;
                httpsBindingElement.MaxBufferSize = int.MaxValue;
                httpsBindingElement.MaxReceivedMessageSize = int.MaxValue;
                result.Elements.Add(httpsBindingElement);
                return result;
            }
            throw new System.InvalidOperationException(string.Format("Could not find endpoint with name \'{0}\'.", endpointConfiguration));
        }
        
        private static System.ServiceModel.EndpointAddress GetEndpointAddress(EndpointConfiguration endpointConfiguration)
        {
            if ((endpointConfiguration == EndpointConfiguration.WSHttpBinding_IService))
            {
                return new System.ServiceModel.EndpointAddress("https://testhcai.ca/R3.21/HCAI.PMSWCFServices/Service.svc");
            }
            throw new System.InvalidOperationException(string.Format("Could not find endpoint with name \'{0}\'.", endpointConfiguration));
        }
        
        private static System.ServiceModel.Channels.Binding GetDefaultBinding()
        {
            return ServiceClient.GetBindingForEndpoint(EndpointConfiguration.WSHttpBinding_IService);
        }
        
        private static System.ServiceModel.EndpointAddress GetDefaultEndpointAddress()
        {
            return ServiceClient.GetEndpointAddress(EndpointConfiguration.WSHttpBinding_IService);
        }
        
        public enum EndpointConfiguration
        {
            
            WSHttpBinding_IService,
        }
    }
}
